Index: src/com/medievaltech/advancewars/GameView.java
===================================================================
--- src/com/medievaltech/advancewars/GameView.java	(revision fea4b77b2fa3d94e79f364cfc993ab5a000df017)
+++ src/com/medievaltech/advancewars/GameView.java	(revision 511177b6d78beb736fc600e9e73145b28a1354be)
@@ -2,4 +2,5 @@
 
 import java.io.*;
+import java.util.*;
 
 import com.medievaltech.advancewars.Enum.*;
@@ -27,7 +28,6 @@
         public Turn mTurn;
         
-        //temporary variable to let the enemy control a specific unit
-        //ownership of units hasn't been implemented yet
-        public Unit enemyUnit;
+        public Player enemy;
+        private Unit selectedUnit;
         
         private int mCanvasHeight = 1;
@@ -35,5 +35,5 @@
 
         private Paint mLinePaint, mTextPaint, mButtonPaint, mTilePaint1,
-        			mTilePaint2, mSelectionPaint, mUnitPaint;
+        			mTilePaint2, mSelectionPaint, mUnitPaint1, mUnitPaint2;
 
         /** Indicate whether the surface has been created & is ready to draw */
@@ -44,5 +44,4 @@
         
         private com.medievaltech.gui.Window wndMainMenu;
-        private Unit selectedUnit;
         
         public DrawingThread(SurfaceHolder surfaceHolder, Context context, Handler handler) {
@@ -73,7 +72,11 @@
             mTilePaint2.setARGB(255, 0, 0, 255);
             
-            mUnitPaint = new Paint();
-            mUnitPaint.setAntiAlias(true);
-            mUnitPaint.setARGB(255, 255, 0, 0);
+            mUnitPaint1 = new Paint();
+            mUnitPaint1.setAntiAlias(true);
+            mUnitPaint1.setARGB(255, 255, 0, 0);
+            
+            mUnitPaint2 = new Paint();
+            mUnitPaint2.setAntiAlias(true);
+            mUnitPaint2.setARGB(255, 160, 160, 255);
             
             mSelectionPaint = new Paint();
@@ -106,9 +109,10 @@
             }
             
-            enemyUnit = new Soldier(mUnitPaint);
-            
-            mMap.getTile(0, 0).addUnit(enemyUnit);
-            mMap.getTile(2, 3).addUnit(new Soldier(mUnitPaint));
-            mMap.getTile(5, 6).addUnit(new Soldier(mUnitPaint));
+            Player humanPlayer = new Player("Human", mUnitPaint1);
+            enemy = new Player("Comp", mUnitPaint2);
+            
+            mMap.getTile(0, 0).addUnit(new Soldier(enemy));
+            mMap.getTile(2, 3).addUnit(new Soldier(humanPlayer));
+            mMap.getTile(5, 6).addUnit(new Soldier(humanPlayer));
             
             mTurn = Turn.YOUR_TURN;
@@ -184,9 +188,24 @@
         	switch(mGameState) {
         	case BATTLE_MAP:
-        		int x = thread.enemyUnit.location.x;
-        		int y = thread.enemyUnit.location.y;
-        		thread.mMap.getTile(x, y).removeUnit();
-				thread.mMap.getTile(x, y+1).addUnit(thread.enemyUnit);
-        		mTurn = Turn.YOUR_TURN;
+        		Iterator<Unit> iter = enemy.getControlledUnits().iterator();
+        		Unit cur;
+        		int x, y;
+        		
+        		Log.i("AdvanceWars", "starting to move enemy units");
+        		while(iter.hasNext()) {
+        			cur = iter.next();
+        			x = cur.location.x;
+            		y = cur.location.y;
+            		
+            		Log.i("AdvanceWars", "moving enemy unit");
+            		
+            		//any unit that's in the way is removed (needs to be changed eventuallyy)
+            		thread.mMap.getTile(x, y).removeUnit();
+    				thread.mMap.getTile(x, y+1).addUnit(cur);
+        		}
+        		Log.i("AdvanceWars", "finished moving enemy units");
+        		
+				
+				mTurn = Turn.YOUR_TURN;
         		break;
         	}
@@ -295,5 +314,7 @@
                 			int y = Integer.parseInt(unit.substring(unit.indexOf(",")+1));
             				
-            				mGame.mThread.mMap.getTile(x, y).addUnit(new Soldier(mGame.mThread.mUnitPaint));
+                			Player humanPlayer = new Player("Human", mGame.mThread.mUnitPaint1);
+                			
+            				mGame.mThread.mMap.getTile(x, y).addUnit(new Soldier(humanPlayer));
             			}
             			
@@ -328,4 +349,6 @@
     			}
     			
+    			Log.i("AdvanceWars", "Touch event handling finished");
+    			
     			break;
     		}